      PROGRAM HWIGPR
C---COMMON BLOCKS ARE INCLUDED AS FILE HERWIG65.INC
      INCLUDE 'HERWIG65.INC'
      INTEGER N
      EXTERNAL HWUDAT
C---MAX NUMBER OF EVENTS THIS RUN
      MAXEV=100
C---BEAM PARTICLES
      PART1='P'
      PART2='P'
C---BEAM MOMENTA
      PBEAM1=7000.
      PBEAM2=7000.
C---PROCESS qq --> W+- --> X
      IPROC=1499
        write(*,*)'C---INITIALISE OTHER COMMON BLOCKS'
      CALL HWIGIN
C---USER CAN RESET PARAMETERS AT
C   THIS POINT, OTHERWISE DEFAULT
C   VALUES IN HWIGIN WILL BE USED.
C... Choosing a PDF set from PDFLIB for both protons:

c      AUTPDF(1)='MRS'
c      MODPDF(1)=28
c      AUTPDF(2)='MRS'
c      MODPDF(2)=28

      AUTPDF(1) = 'HWLHAPDF'
      AUTPDF(2) = 'HWLHAPDF'
        write(*,*)
     &   'C... CTEQ6M, see http://hepforge.cedar.ac.uk/lhapdf/manual:'
      MODPDF(1) = 10000
      MODPDF(2) = 10000
C....................................
      PTMIN=100.
        write(*,*)'C---COMPUTE PARAMETER-DEPENDENT CONSTANTS'
      CALL HWUINC
C---CALL HWUSTA TO MAKE ANY PARTICLE STABLE
c      CALL HWUSTA('PI0     ')
        write(*,*)'C---USER''S INITIAL CALCULATIONS'
      CALL HWABEG
C---INITIALISE ELEMENTARY PROCESS
      write(*,*) 'call hweini ..'
      CALL HWEINI
      write(*,*) 'loop ...'
C---LOOP OVER EVENTS
      DO 100 N=1,MAXEV
C---INITIALISE EVENT
      CALL HWUINE
C---GENERATE HARD SUBPROCESS
      CALL HWEPRO
C---GENERATE PARTON CASCADES
      CALL HWBGEN
C---DO HEAVY OBJECT DECAYS
      CALL HWDHOB
C---DO CLUSTER FORMATION
      CALL HWCFOR
C---DO CLUSTER DECAYS
      CALL HWCDEC
C---DO UNSTABLE PARTICLE DECAYS
      CALL HWDHAD
C---DO HEAVY FLAVOUR HADRON DECAYS
      CALL HWDHVY
C---ADD SOFT UNDERLYING EVENT IF NEEDED
      CALL HWMEVT
C---FINISH EVENT
      CALL HWUFNE
C---USER'S EVENT ANALYSIS
      CALL HWANAL
  100 CONTINUE
C---TERMINATE ELEMENTARY PROCESS
      CALL HWEFIN
C---USER'S TERMINAL CALCULATIONS
      CALL HWAEND
      STOP
      END
C----------------------------------------------------------------------
      SUBROUTINE HWABEG
C     USER'S ROUTINE FOR INITIALIZATION
C----------------------------------------------------------------------
      END
C----------------------------------------------------------------------
      SUBROUTINE HWAEND
C     USER'S ROUTINE FOR TERMINAL CALCULATIONS, HISTOGRAM OUTPUT, ETC
C----------------------------------------------------------------------
      END
C----------------------------------------------------------------------
      SUBROUTINE HWANAL
C     USER'S ROUTINE TO ANALYSE DATA FROM EVENT
C----------------------------------------------------------------------
      END
C----------------------------------------------------------------------
