CDECK  ID>, HWHREM.
*CMZ :-        -01/06/94  17.03.31  by  Mike Seymour
*-- Author :    Mike Seymour
C-----------------------------------------------------------------------
      SUBROUTINE HWHREM(IBEAM,ITARG)
C-----------------------------------------------------------------------
C     IDENTIFY THE REMNANTS OF THE HARD SCATTERING
C     AND BREAK THEIR COLOUR CONNECTION IF NECESSARY
C-----------------------------------------------------------------------
#include "HERWIG65.INC"
      DOUBLE PRECISION PCL(5),
     $     P1P2,P1SQ,P2SQ,S,M1SQ,M2SQ,TMP1,TMP2,A,B,C,D,PTOT(4),HWULDO
      INTEGER IBEAM,ITARG,IHEP,NTEMP,I,ICOL,IANT
      LOGICAL LTEMP,T,COL,ANT
      PARAMETER (T=.TRUE.)
      COL(I)=I.EQ.13 .OR. I.GE.1.AND.I.LE.6 .OR. I.GE.115.AND.I.LE.120
      ANT(I)=I.EQ.13 .OR. I.GE.7.AND.I.LE.12.OR. I.GE.109.AND.I.LE.114
C---LOOK FOR UNTREATED BEAM AND TARGET REMNANTS
      IBEAM=0
      ITARG=0
      DO 10 IHEP=1,NHEP
        IF (ISTHEP(IHEP).EQ.148) THEN
          IF (ITARG.NE.0) THEN
            CALL HWWARN('HWHREM',100)
            GOTO 999
          ENDIF
          ITARG=IHEP
        ELSEIF (ISTHEP(IHEP).EQ.147) THEN
          IF (IBEAM.NE.0) THEN
            CALL HWWARN('HWHREM',101)
            GOTO 999
          ENDIF
          IBEAM=IHEP
        ENDIF
  10  CONTINUE
      IF (ITARG.EQ.0) THEN
        CALL HWWARN('HWHREM',102)
        GOTO 999
      ENDIF
      IF (IBEAM.EQ.0) THEN
        CALL HWWARN('HWHREM',103)
        GOTO 999
      ENDIF
C---MHS FIX TO PREVENT MOMENTUM VIOLATION DUE TO OFF-SHELL BEAM REMNANTS
C---FIND REMNANT MOMENTA AND MASSES
      P1P2=HWULDO(PHEP(1,IBEAM),PHEP(1,ITARG))
      P1SQ=HWULDO(PHEP(1,IBEAM),PHEP(1,IBEAM))
      P2SQ=HWULDO(PHEP(1,ITARG),PHEP(1,ITARG))
      S=P1SQ+2*P1P2+P2SQ
      TMP1=P1P2**2-P1SQ*P2SQ
      IF (TMP1.LE.0) THEN
        CALL HWWARN('HWHREM',104)
        GOTO 999
      ENDIF
      TMP1=SQRT(TMP1)
      M1SQ=RMASS(IDHW(IBEAM))**2
      M2SQ=RMASS(IDHW(ITARG))**2
      TMP2=(S-M1SQ-M2SQ)**2-4*M1SQ*M2SQ
      IF (TMP2.LE.0) THEN
        CALL HWWARN('HWHREM',105)
        GOTO 999
      ENDIF
      TMP2=SQRT(TMP2)
C---EXCHANGE A LITTLE MOMENTUM TO PUT THEM BOTH ON MASS-SHELL
      A=(1-(P1P2+P2SQ)/TMP1)/2
      B=(1-(P1P2+P1SQ)/TMP1)/2
      C=(S-M1SQ+M2SQ-TMP2)/(2*S)
      D=(S+M1SQ-M2SQ-TMP2)/(2*S)
      CALL HWVSUM(4,PHEP(1,IBEAM),PHEP(1,ITARG),PTOT)
      CALL HWVSCA(4,(1-A)*(1-C)+A*D,PHEP(1,IBEAM),PHEP(1,IBEAM))
      CALL HWVSCA(4,B*(1-C)+(1-B)*D,PHEP(1,ITARG),PHEP(1,ITARG))
      CALL HWVSUM(4,PHEP(1,IBEAM),PHEP(1,ITARG),PHEP(1,IBEAM))
      CALL HWVDIF(4,PTOT,PHEP(1,IBEAM),PHEP(1,ITARG))
      CALL HWUMAS(PHEP(1,IBEAM))
      CALL HWUMAS(PHEP(1,ITARG))
C---END MHS FIX
C---IF THEY ARE COLOUR CONNECTED, DISCONNECT THEM BY EMITTING A SOFT
C   GLUON AND SPLITTING THAT GLUON TO LIGHT QUARKS
C  (WHICH NORMALLY GETS DONE AS THE FIRST STAGE OF CLUSTER FORMATION)
C---LOOP OVER COLOUR/ANTICOLOUR LINE
      DO 20 I=1,2
        IF (I.EQ.1) THEN
          ICOL=IBEAM
          IANT=ITARG
        ELSE
          ICOL=ITARG
          IANT=IBEAM
        ENDIF
        IF (COL(IDHW(ICOL)).AND.ANT(IDHW(IANT)).AND.
     $       JMOHEP(2,ICOL).EQ.IANT.AND.JDAHEP(2,IANT).EQ.ICOL) THEN
          CALL HWVSUM(4,PHEP(1,ICOL),PHEP(1,IANT),PCL)
          CALL HWUMAS(PCL)
          NTEMP=NHEP
          CALL HWCCUT(ICOL,IANT,PCL,T,LTEMP)
          IF (IERROR.NE.0) RETURN
C---IF NOTHING WAS CREATED THEY MUST BE BELOW THRESHOLD, SO GIVE UP
          IF (NHEP.NE.NTEMP+2) RETURN
C---RELABEL THEM AS PERTUBATIVE JUST TO NEATEN UP THE EVENT RECORD
          ISTHEP(NHEP-1)=149
          ISTHEP(NHEP)=149
        ENDIF
 20   CONTINUE
 999  RETURN
      END
