CDECK  ID>, HWSMRS.
*CMZ :-        -26/04/01  10.00.16  by  Peter Richardson
*-- Author :    Dick Roberts, modified by Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWSMRS(X,Q,MODE,UPV,DNV,USEA,DSEA,STR,CHM,BOT,GLU)
C-----------------------------------------------------------------------
C     MRST98 Leading order PDF's central and higher gluon + average
C-----------------------------------------------------------------------
#include "HERWIG65.INC"
      DOUBLE PRECISION X,Q,UPV,DNV,USEA,DSEA,STR,CHM,BOT,GLU,XMIN,XMAX,
     &     QSQMIN,QSQMAX,Q2,QQ(NQMRS),XXMRS(NXMRS),G(NPMRS),N0(NPMRS),
     &     XSAVE,Q2SAVE,XXX,A,B,FAC
      INTEGER MODE,INIT,NTENTH,N,M,I,J,K,ML,WARN(2)
      PARAMETER(NTENTH=23)
      SAVE INIT,WARN,XMIN,XMAX,QSQMIN,QSQMAX,XXMRS,QQ,N0
      DATA XMIN,XMAX,QSQMIN,QSQMAX/1D-5,1D0,1.25D0,1D7/
      DATA XXMRS/1d-5,2d-5,4d-5,6d-5,8d-5,
     &        1d-4,2d-4,4d-4,6d-4,8d-4,
     &        1d-3,2d-3,4d-3,6d-3,8d-3,
     &        1d-2,1.4d-2,2d-2,3d-2,4d-2,6d-2,8d-2,
     &     .1d0,.125d0,.15d0,.175d0,.2d0,.225d0,.25d0,.275d0,
     &     .3d0,.325d0,.35d0,.375d0,.4d0,.425d0,.45d0,.475d0,
     &     .5d0,.525d0,.55d0,.575d0,.6d0,.65d0,.7d0,.75d0,
     &     .8d0,.9d0,1d0/
      DATA QQ/1.25d0,1.5d0,2d0,2.5d0,3.2d0,4d0,5d0,6.4d0,8d0,1d1,
     &        1.2d1,1.8d1,2.6d1,4d1,6.4d1,1d2,
     &        1.6d2,2.4d2,4d2,6.4d2,1d3,1.8d3,3.2d3,5.6d3,1d4,
     &        1.8d4,3.2d4,5.6d4,1d5,1.8d5,3.2d5,5.6d5,1d6,
     &        1.8d6,3.2d6,5.6d6,1d7/
      DATA N0/3,4,5,9,9,9,9,9/
      DATA INIT,WARN/0,0,0/
      Q2=Q*Q
C--issue warning if x or q out of range
      IF((Q2.LT.QSQMIN.OR.Q2.GT.QSQMAX).AND.WARN(1).EQ.0) THEN
        CALL HWWARN('HWSMRS',5)
        WRITE (6,'(2A)') ' WARNING: MRST98 CALLED WITH Q',
     &         ' OUTSIDE ALLOWED RANGE!'
        WRITE (6,'(1P,3(A,E9.3))') ' Q VALUE=',Q,
     &         ', MINIMUM=',SQRT(QSQMIN),', MAXIMUM=',SQRT(QSQMAX)
        WRITE (6,'(A)') ' NO FURTHER WARNINGS WILL BE ISSUED'
        WARN(1) = 1
      ENDIF
      IF((X.LT.XMIN.OR.X.GT.XMAX).AND.WARN(2).EQ.0) THEN
        CALL HWWARN('HWSMRS',4)
        WRITE (6,'(2A)') ' WARNING: MRST98 CALLED WITH X',
     &         ' OUTSIDE ALLOWED RANGE!'
        WRITE (6,'(1P,3(A,E9.3))') ' X VALUE=',X,
     &         ', MINIMUM=',XMIN,', MAXIMUM=',XMAX
        WRITE (6,'(A)') ' NO FURTHER WARNINGS WILL BE ISSUED'
        WARN(2) = 1
      ENDIF
C--now the evaluation
      XSAVE  = X
      Q2SAVE = Q2
C--first the initialisation
      IF(INIT.NE.0) GOTO 10
      DO 15 ML=3,1,-1
      DO 20 N=1,NXMRS-1
      DO 20 M=1,NQMRS
      DO 20 I=1,NPMRS
c notation: 1=uval 2=val 3=glue 4=usea 5=chm 6=str 7=btm 8=dsea
        IF(ML.LE.2) THEN
          FMRS(ML,I,N,M) = FMRS(ML,I,N,M)/(1.0D0-XXMRS(N))**N0(I)
        ELSE
          FMRS(ML,I,N,M) = 0.5D0*(FMRS(1,I,N,M)+FMRS(2,I,N,M))/
     &                              (1.0D0-XXMRS(N))**N0(I)
        ENDIF
 20   CONTINUE
      DO 31 J=1,NTENTH-1
      DO 31 I=1,8
      IF(I.EQ.5.OR.I.EQ.7) GOTO 31
      DO 30 K=1,NQMRS
 30   FMRS(ML,I,J,K)=DLOG10(FMRS(ML,I,J,K)/FMRS(ML,I,NTENTH,K))
     &                 +FMRS(ML,I,NTENTH,K)
 31   CONTINUE
      DO 40 I=1,NPMRS
      DO 40 M=1,NQMRS
 40   FMRS(ML,I,NXMRS,M)=0.0D0
 15   CONTINUE
      DO 32 J=1,NTENTH-1
 32   XXMRS(J)=DLOG10(XXMRS(J)/XXMRS(NTENTH))+XXMRS(NTENTH)
      INIT=1
 10   CONTINUE
C--check x and q within range of set
      IF(X.LT.XMIN) X=XMIN
      IF(X.GT.XMAX) X=XMAX
      IF(Q2.LT.QSQMIN)  Q2=QSQMIN
      IF(Q2.GT.QSQMAX)  Q2=QSQMAX
C--find X and Q
      XXX=X
      IF(X.LT.XXMRS(NTENTH)) XXX=DLOG10(X/XXMRS(NTENTH))+XXMRS(NTENTH)
      N = 0
 70   N=N+1
      IF(XXX.GT.XXMRS(N+1)) GOTO 70
      A=(XXX-XXMRS(N))/(XXMRS(N+1)-XXMRS(N))
      M=0
 80   M=M+1
      IF(Q2.GT.QQ(M+1)) GOTO 80
      B=(Q2-QQ(M))/(QQ(M+1)-QQ(M))
      DO 60 I=1,NPMRS
      G(I)= (1.0D0-A)*(1.0D0-B)*FMRS(MODE,I,N  ,M  )
     &     +(1.0D0-A)*       B *FMRS(MODE,I,N  ,M+1)
     &     +       A *(1.0D0-B)*FMRS(MODE,I,N+1,M  )
     &     +       A *       B *FMRS(MODE,I,N+1,M+1)
      IF(N.GE.NTENTH) GOTO 65
      IF(I.EQ.5.OR.I.EQ.7) GOTO 65
      FAC  = (1.0D0-B)*FMRS(MODE,I,NTENTH,M)+B*FMRS(MODE,I,NTENTH,M+1)
      G(I) = FAC*10.0d0**(G(I)-FAC)
  65  continue
      G(I)=G(I)*(1.0d0-X)**N0(I)
  60  continue
      UPV  = G(1)
      DNV  = G(2)
      USEA = G(4)
      DSEA = G(8)
      STR  = G(6)
      CHM  = G(5)
      GLU  = G(3)
      BOT  = G(7)
      X    = XSAVE
      Q2   = Q2SAVE
      END
